#-*-coding:utf-8*-*

from os.path import join
from creole.loader import config_save_values
from eolegenconfig import lib
ID_ = 'test'
DICO_DIR = '/usr/share/creole/tests/dicos'
CONFIG_DIR = '/usr/share/creole/tests/configs'

def _calc_config_file(test):
    """
    nom du fichier eol lié au test
    """
    return join(CONFIG_DIR, '{0}.eol'.format(test))

def _load(test):
    """
    Chargement des dictionnaires liés au test
    Initialisation du fichier eol lié au test
    """
    config_file = _calc_config_file(test)
    file(config_file, 'w')
    return lib.get_config(ID_, force_dirs=join(DICO_DIR, test),
                          force_configfile=config_file)

def _save(test):
    """
    Enregistement des données
    """
    config_file = _calc_config_file(test)
    config = lib.get_config(ID_)
    config_save_values(config, 'creole', eol_file=config_file)

def test_calc_multi_condition():
    """
    calc_multi_condition avec une variable désactivée #8439
    """
    config = _load('multicondition')
    assert config.creole.test.resultat == 'resultat2'
    lib.set_value(ID_, 'test', 'condition', 'non')
    assert config.creole.test.resultat == 'resultat1'

def test_auto_save():
    """
    auto_save sur une variable multi (#8020)
    """
    config = _load('autosave')
    assert config.creole.test.autosave == [u'a', u'b']
    _save('autosave')
    content = eval(file(_calc_config_file('autosave')).read())
    assert content == {'autosave': {'owner': 'gen_config', 'val': [u'a', u'b']}}
